//<copyright-disclaimer-start>
//  **************************************************************************************************************
//  * © 2025 Advanced Micro Devices, Inc. All rights reserved.                                                   *
//  * DISCLAIMER                                                                                                 *
//  * The information contained herein is for informational purposes only, and is subject to change              *
//  * without notice. While every precaution has been taken in the preparation of this document, it              *
//  * may contain technical inaccuracies, omissions and typographical errors, and AMD is under no                *
//  * obligation to update or otherwise correct this information.  Advanced Micro Devices, Inc. makes            *
//  * no representations or warranties with respect to the accuracy or completeness of the contents of           *
//  * this document, and assumes no liability of any kind, including the implied warranties of noninfringement,  *
//  * merchantability or fitness for particular purposes, with respect to the operation or use of AMD            *
//  * hardware, software or other products described herein.  No license, including implied or                   *
//  * arising by estoppel, to any intellectual property rights is granted by this document.  Terms and           *
//  * limitations applicable to the purchase or use of AMD’s products are as set forth in a signed agreement     *
//  * between the parties or in AMD's Standard Terms and Conditions of Sale. GD-18                               *
//  *                                                                                                            *
//  **************************************************************************************************************
//<copyright-disclaimer-end>

#include "kernels.h"

int32 LUT[NUM_SAMPLES] = {1,2,3,4,5,6,7,8};

void vitis_single_node_templates(adf::input_buffer<int32> & bufin, adf::output_buffer<int32> & bufout, input_stream_int32* sin, output_stream_int32* sout, const int (&vectorIn)[NUM_SAMPLES], int factorIn, int (&vectorOut)[NUM_SAMPLES], int& factorOut ){
  int32 bc1, sc1;
  int32* inItr = bufin.data();
  int32* outItr = bufout.data();
  for(int i = 0; i < NUM_SAMPLES; i++)
  {
    
    bc1 = *inItr++;
    bc1 = bc1 + 5 + LUT[i];
    *outItr++ = bc1;
    
    sc1 = readincr(sin);
    sc1 = sc1 + 5;
    writeincr(sout, sc1);

    vectorOut[i] = vectorIn[i] + 5;
    factorOut = factorIn + 5;
	
  }
}

