//<copyright-disclaimer-start>
//  **************************************************************************************************************
//  * © 2025 Advanced Micro Devices, Inc. All rights reserved.                                                   *
//  * DISCLAIMER                                                                                                 *
//  * The information contained herein is for informational purposes only, and is subject to change              *
//  * without notice. While every precaution has been taken in the preparation of this document, it              *
//  * may contain technical inaccuracies, omissions and typographical errors, and AMD is under no                *
//  * obligation to update or otherwise correct this information.  Advanced Micro Devices, Inc. makes            *
//  * no representations or warranties with respect to the accuracy or completeness of the contents of           *
//  * this document, and assumes no liability of any kind, including the implied warranties of noninfringement,  *
//  * merchantability or fitness for particular purposes, with respect to the operation or use of AMD            *
//  * hardware, software or other products described herein.  No license, including implied or                   *
//  * arising by estoppel, to any intellectual property rights is granted by this document.  Terms and           *
//  * limitations applicable to the purchase or use of AMD’s products are as set forth in a signed agreement     *
//  * between the parties or in AMD's Standard Terms and Conditions of Sale. GD-18                               *
//  *                                                                                                            *
//  **************************************************************************************************************
//<copyright-disclaimer-end>

#pragma once

// Multiply 2 matrices   (MxK) x (KxN)
#define A_ROWS sizeM
#define A_COLS sizeK

#define B_ROWS A_COLS
#define B_COLS sizeN

#define C_ROWS A_ROWS
#define C_COLS B_COLS

// // Input/Output Matrix Type
// #define ITYPE int8
// #define OTYPE int16
// #define SHIFT_RESULT 6

// Non Sparse Tiling: 4x16x8

#define ATILES_ROWS subM
#define ATILES_COLS subK
#define BTILES_ROWS ATILES_COLS
#define BTILES_COLS subN
#define CTILES_ROWS ATILES_ROWS
#define CTILES_COLS BTILES_COLS

// Sparse Tiling: 4x16x8

// #define ATILES_ROWS_S subM
// #define ATILES_COLS_S subK
// #define BTILES_ROWS_S ATILES_COLS_S
// #define BTILES_COLS_S subN
// #define CTILES_ROWS_S ATILES_ROWS_S
// #define CTILES_COLS_S BTILES_COLS_S


// Simulation length
#define NITERATIONS NIterations
